
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef p3d_TCLSERV_CLIENT_ERROR_H
#define p3d_TCLSERV_CLIENT_ERROR_H

#include <server/p3dError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum p3d_error {
	E_p3d_OK					  			= 0,

	/* module errors */
	E_p3d_ETOOMANY                       = S_p3d_ETOOMANY,
	E_p3d_HILO_ORDER                     = S_p3d_HILO_ORDER,
	E_p3d_PLACEMENT_FAILED               = S_p3d_PLACEMENT_FAILED,
	E_p3d_BAD_PARAMS                     = S_p3d_BAD_PARAMS,
	E_p3d_ENOENT                         = S_p3d_ENOENT,
	E_p3d_ENOPOSTER                      = S_p3d_ENOPOSTER,
	E_p3d_EINVAL                         = S_p3d_EINVAL,
	E_p3d_POSTER_READ                    = S_p3d_POSTER_READ,
	E_p3d_BLOCKED                        = S_p3d_BLOCKED,
	E_p3d_NO_PATH                        = S_p3d_NO_PATH,
	E_p3d_POSTER_NOT_FOUND               = S_p3d_POSTER_NOT_FOUND,


	/* std errors */
	E_p3d_ACTIVITY_INTERRUPTED           = S_p3d_stdGenoM_ACTIVITY_INTERRUPTED,
	E_p3d_TOO_MANY_ACTIVITIES            = S_p3d_stdGenoM_TOO_MANY_ACTIVITIES,
	E_p3d_ACTIVITY_FAILED                = S_p3d_stdGenoM_ACTIVITY_FAILED,
	E_p3d_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_p3d_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_p3d_UNKNOWN_ACTIVITY               = S_p3d_stdGenoM_UNKNOWN_ACTIVITY,
	E_p3d_FORBIDDEN_ACTIVITY_TRANSITION  = S_p3d_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_p3d_SYSTEM_ERROR                   = S_p3d_stdGenoM_SYSTEM_ERROR,
	E_p3d_ACTIVITY_ALREADY_ENDED         = S_p3d_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_p3d_WAIT_INIT_RQST                 = S_p3d_stdGenoM_WAIT_INIT_RQST,
	E_p3d_CONTROL_CODEL_ERROR            = S_p3d_stdGenoM_CONTROL_CODEL_ERROR,
	E_p3d_EXEC_TASK_SUSPENDED            = S_p3d_stdGenoM_EXEC_TASK_SUSPENDED,
	E_p3d_BAD_BLOCK_TYPE                 = S_p3d_stdGenoM_BAD_BLOCK_TYPE,
	E_p3d_BAD_POSTER_TYPE                = S_p3d_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum p3d_error p3d_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int p3d_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the p3d context.
 *
 * Returns NULL in case of failure
 */
const char* p3d_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
