
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef p3d_TCLSERV_CLIENT_MSG_LIB_H
#define p3d_TCLSERV_CLIENT_MSG_LIB_H

#include <server/p3dType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int p3dTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int p3dTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int p3dTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 P3D_INIT *(in_initParams) 
		);

int p3dTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int p3dTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				P3D_INIT *(in_initParams) ,
				
				int *bilan);

int p3dTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					P3D_INIT *(in_initParams) ,
					
					int *bilan);




int p3dTclservClientGoToStopRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int p3dTclservClientGoToStopReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int p3dTclservClientGoToStopRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int p3dTclservClientGoToRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 P3DWayPoint *(in_wpP) 
		);

int p3dTclservClientGoToReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int p3dTclservClientGoToRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				P3DWayPoint *(in_wpP) ,
				
				int *bilan);

int p3dTclservClientGoToRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					P3DWayPoint *(in_wpP) ,
					
					int *bilan);




int p3dTclservClientGetLamaGeomRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int p3dTclservClientGetLamaGeomReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       P3DLamaGeom *(out_geomP),
			       int *bilan);

int p3dTclservClientGetLamaGeomRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 P3DLamaGeom *(out_geomP),
				 int *bilan);




int p3dTclservClientSetLamaGeomRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 P3DLamaGeom *(in_geomP) 
		);

int p3dTclservClientSetLamaGeomReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int p3dTclservClientSetLamaGeomRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				P3DLamaGeom *(in_geomP) ,
				
				int *bilan);

int p3dTclservClientSetLamaGeomRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					P3DLamaGeom *(in_geomP) ,
					
					int *bilan);




int p3dTclservClientGetLamaLimitsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int p3dTclservClientGetLamaLimitsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       P3DLamaLimits *(out_limitsP),
			       int *bilan);

int p3dTclservClientGetLamaLimitsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 P3DLamaLimits *(out_limitsP),
				 int *bilan);




int p3dTclservClientSetLamaLimitsRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 P3DLamaLimits *(in_limitsP) 
		);

int p3dTclservClientSetLamaLimitsReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int p3dTclservClientSetLamaLimitsRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				P3DLamaLimits *(in_limitsP) ,
				
				int *bilan);

int p3dTclservClientSetLamaLimitsRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					P3DLamaLimits *(in_limitsP) ,
					
					int *bilan);




int p3dTclservClientGetArcsParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int p3dTclservClientGetArcsParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       P3DArcsParams *(out_arcsP),
			       int *bilan);

int p3dTclservClientGetArcsParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 P3DArcsParams *(out_arcsP),
				 int *bilan);




int p3dTclservClientSetArcsParamsRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 P3DArcsParams *(in_arcsP) 
		);

int p3dTclservClientSetArcsParamsReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int p3dTclservClientSetArcsParamsRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				P3DArcsParams *(in_arcsP) ,
				
				int *bilan);

int p3dTclservClientSetArcsParamsRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					P3DArcsParams *(in_arcsP) ,
					
					int *bilan);




int p3dTclservClientSetGoalParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 P3DPlanParams *(in_planP)
		);

int p3dTclservClientSetGoalParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int p3dTclservClientSetGoalParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 P3DPlanParams *(in_planP) ,
				 
				 int *bilan);




int p3dTclservClientGetGoalParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int p3dTclservClientGetGoalParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       P3DPlanParams *(out_planP),
			       int *bilan);

int p3dTclservClientGetGoalParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 P3DPlanParams *(out_planP),
				 int *bilan);




int p3dTclservClientAddWayPointRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 P3DWayPoint *(in_wpP)
		);

int p3dTclservClientAddWayPointReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int p3dTclservClientAddWayPointRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 P3DWayPoint *(in_wpP) ,
				 
				 int *bilan);




int p3dTclservClientClearWayPointsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int p3dTclservClientClearWayPointsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int p3dTclservClientClearWayPointsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int p3dTclservClientClearCurrentWayPointRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int p3dTclservClientClearCurrentWayPointReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int p3dTclservClientClearCurrentWayPointRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int p3dTclservClientTrackRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 P3DSDIIo *(in_trackP) 
		);

int p3dTclservClientTrackReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int p3dTclservClientTrackRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				P3DSDIIo *(in_trackP) ,
				
				int *bilan);

int p3dTclservClientTrackRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					P3DSDIIo *(in_trackP) ,
					
					int *bilan);




int p3dTclservClientTrackStopRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int p3dTclservClientTrackStopReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int p3dTclservClientTrackStopRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int p3dTclservClientTrackStopRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int p3dTclservClientSetP3dPosterRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GEN_STRING64 *(in_demP3dPosterName)
		);

int p3dTclservClientSetP3dPosterReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int p3dTclservClientSetP3dPosterRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GEN_STRING64 *(in_demP3dPosterName) ,
				 
				 int *bilan);




int p3dTclservClientReadDemP3dPosterRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GEN_STRING64 *(in_demP3dPosterName) 
		);

int p3dTclservClientReadDemP3dPosterReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int p3dTclservClientReadDemP3dPosterRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GEN_STRING64 *(in_demP3dPosterName) ,
				
				int *bilan);

int p3dTclservClientReadDemP3dPosterRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GEN_STRING64 *(in_demP3dPosterName) ,
					
					int *bilan);




int p3dTclservClientSaveP3dMapRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 P3D_SAVEMAP_PARAMS *(in_p3dSaveMapParams) 
		);

int p3dTclservClientSaveP3dMapReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int p3dTclservClientSaveP3dMapRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				P3D_SAVEMAP_PARAMS *(in_p3dSaveMapParams) ,
				
				int *bilan);

int p3dTclservClientSaveP3dMapRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					P3D_SAVEMAP_PARAMS *(in_p3dSaveMapParams) ,
					
					int *bilan);




int p3dTclservClientPlaceRobotOnMapRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 P3D_PLACEROBOT_PARAMS *(in_placeRobotPos) 
		);

int p3dTclservClientPlaceRobotOnMapReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int p3dTclservClientPlaceRobotOnMapRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				P3D_PLACEROBOT_PARAMS *(in_placeRobotPos) ,
				
				int *bilan);

int p3dTclservClientPlaceRobotOnMapRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					P3D_PLACEROBOT_PARAMS *(in_placeRobotPos) ,
					
					int *bilan);




int p3dTclservClientConfigMonitorRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 P3D_MONITOR_PARAMS *(in_monitorParams) 
		);

int p3dTclservClientConfigMonitorReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int p3dTclservClientConfigMonitorRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				P3D_MONITOR_PARAMS *(in_monitorParams) ,
				
				int *bilan);

int p3dTclservClientConfigMonitorRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					P3D_MONITOR_PARAMS *(in_monitorParams) ,
					
					int *bilan);




int p3dTclservClientStopMonitorRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int p3dTclservClientStopMonitorReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int p3dTclservClientStopMonitorRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int p3dTclservClientGetDumpParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int p3dTclservClientGetDumpParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       P3D_DUMP_PARAMS *(out_dumpParams),
			       int *bilan);

int p3dTclservClientGetDumpParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 P3D_DUMP_PARAMS *(out_dumpParams),
				 int *bilan);




int p3dTclservClientSetDumpParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 P3D_DUMP_PARAMS *(in_dumpParams)
		);

int p3dTclservClientSetDumpParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int p3dTclservClientSetDumpParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 P3D_DUMP_PARAMS *(in_dumpParams) ,
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* p3dTCLSERV_CLIENT_MSG_LIB_H */

